import axipy
from axipy import init_axioma, AxiomaInitLogLevel, Feature

from ru_axioma_gis_add_geo_tools.tools.line_pairing.tools.map_add_tools import shapely_to_minimum_rotated_rectangle

app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_tab=r"E:\Support\AxiomaTesting\Shapely\min_rotate_rect_1.TAB"
tab=axipy.provider_manager.openfile(path_tab)
geo_col=axipy.GeometryCollection(tab.coordsystem)
for ft in tab.items():
    if ft.geometry is not None:
        geo_col.append(ft.geometry)
axi_min_rect=shapely_to_minimum_rotated_rectangle(geo_col,tab.coordsystem)
ft_new=Feature(geometry=axi_min_rect)
tab.insert(ft_new)
tab.commit()
tab.close()

app.exit()