from axipy import UnitValue, LinearUnits, AxiomaInitLogLevel, init_axioma, provider_manager, Feature

from ru_axioma_gis_add_geo_tools.tools.parallel_linestring.create_parallel import ParamsOffset, TypeOffset, \
    createParallel

app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
value_offset=UnitValue(500,LinearUnits.cm)
params=ParamsOffset(value_offset,TypeOffset.Rigth)
path_tab=r"E:\Support\AxiomaTesting\Shapely\test_2.tab"
tab=provider_manager.openfile(path_tab)
for ft in tab.items():
    geometry=ft.geometry
    geo_left,geo_right=createParallel(geometry,params)
    new_ft=None
    if params.type_offset==TypeOffset.Left:
        new_ft=Feature(geometry=geo_left)

    if params.type_offset==TypeOffset.Rigth:
        new_ft=Feature(geometry=geo_right)
    if new_ft is not None:
        tab.insert(new_ft)
tab.commit()
app.exit()
print("End")