from axipy import Geometry, Pnt, CoordSystem, init_axioma, AxiomaInitLogLevel, provider_manager

from ru_axioma_gis_add_geo_tools.tools.orthogonalization.tools.add_helper import PntToTuplesRevers
from ru_axioma_gis_add_geo_tools.tools.orthogonalization.tools.orthogonalize_polygon import \
    calculate_initial_compass_bearing, calculate_segment_anglesAxi

app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_tab=r"E:\Support\AxiomaTesting\orthogonalization\test1.tab"
tab=provider_manager.openfile(path_tab)
fts=list(tab.items())
geometry=fts[0].geometry
points=geometry.points
for i in range(len(points)-1):
    point_1=PntToTuplesRevers(points[i])
    point_2 = PntToTuplesRevers(points[i+1])

    angle=calculate_initial_compass_bearing(point_1,point_2)
    dist,ang_axi=Geometry.distance_by_points(points[i],points[i+1],tab.coordsystem)
    print(" angle="+str(angle))
    print("axi_aziumut="+str(ang_axi))
orgAngle, corAngle, dirAngle=calculate_segment_anglesAxi(points,tab.coordsystem)
app.exit()