import axipy
from axipy import AxiomaInitLogLevel, init_axioma, Feature, Pnt

from ru_axioma_gis_add_geo_tools.tools.line_pairing.tools.pairing_geo_object import SegmentDescription, GeometryPairing


app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_tab=r"E:\Support\AxiomaTesting\Shapely\base_line_2n.TAB"
#path_tab=r"E:\Support\AxiomaTesting\Shapely\base_line_2n_base.TAB"
tab=axipy.provider_manager.openfile(path_tab)
fts=list(tab.items())
geo_line_1=fts[0].geometry
geo_line_2=fts[1].geometry
pnt_1_intersect=Pnt(214.105735,232.985476)
#pnt_1_intersect=Pnt(214.105735,362.121501)
pnt_2_intersect=Pnt(288.953186,214.422212)
seg_prop_1=SegmentDescription(fts[0].id,geo_line_1.type,geo_line_1,pnt_1_intersect,None)
seg_prop_2=SegmentDescription(fts[1].id,geo_line_1.type,geo_line_2,pnt_2_intersect,None)
#cls_Pair=LinePairing(geo_line_1,geo_line_2)
cls_Pair=GeometryPairing(seg_prop_1,seg_prop_2)
new_geo_line1,new_geo_line_2,pair_polyline=cls_Pair.build(14)
new_ft=Feature(geometry=pair_polyline,style=fts[0].style)
tab.insert(new_ft)
if new_geo_line1 is not None:
    new_ft = Feature(geometry=new_geo_line1, style=fts[0].style)
    tab.insert(new_ft)
if new_geo_line_2 is not None:
    new_ft = Feature(geometry=new_geo_line_2, style=fts[0].style)
    tab.insert(new_ft)
tab.commit()
tab.close()
app.exit()
print("End")