import axipy
from axipy import Observer, view_manager, MapView


def factoruObserverForPair(name="ActiveMapEditableLayer"):
    observer = axipy.observer_manager.get(name)
    if observer is not None:
        return observer
    observer = Observer(name, False)
    def change_active_view():
        if not isinstance(view_manager.active,MapView):
            if observer.value :
                observer.value=False
            return
        if view_manager.active.editable_layer is None:
            if observer.value :
                observer.value=False
            return

        observer.value = True

    axipy.view_manager.active_changed.connect(change_active_view)
    change_active_view()
    return observer
