import axipy
from axipy import Observer, MapView, GeometryClass, data_manager

from ru_axioma_gis_add_geo_tools.tools.add_helper.tab_helper import tabInMap, MapExistrEditableLayer


def factoryObserver(name="SelectLineStringInMap"):

    observer =  axipy.observer_manager.get(name)
    if observer is not None:
        return observer
    observer=Observer(name,False)
    def select_obj():
        if not isinstance(axipy.view_manager.active,MapView):
            '''
            if view_map_active is not None:
                view_map_active.editable_layer_changed.disconnect(select_obj)
            '''
            if axipy.selection_manager.count==0 :
                if observer.value:
                    observer.value=False
            return
        #existEditableLayer=MapExistrEditableLayer(axipy.view_manager.active.map)
        #view_map_active=axipy.view_manager.active
        '''
        existEditableLayer=False

        if axipy.view_manager.active.map.editable_layer is not None:
            existEditableLayer=True
        if not existEditableLayer:
            if observer.value:
                observer.value=False
            return
        '''
        tab_selection=axipy.selection_manager.get_as_table()

        if tab_selection is None or  (tabInMap(axipy.view_manager.active.map,tab_selection.base_table) is None) :
            if observer.value:
                observer.value=False
            return
        type_geometry=tab_selection.base_table.class_geometries()
        if len(type_geometry)==1 and type_geometry[0]==GeometryClass.Lines:
            if not observer.value:
                observer.value=True
            return
        sql="Select Count(*) as count from Выборка"+' where Str$(obj)="Line" or Str$(obj)="Polyline"'
        type_obj_tab=data_manager.query_hidden(sql)
        if type_obj_tab is None or type_obj_tab.count()==0 or list(type_obj_tab.items())[0]['count']==0:
            if type_obj_tab is not None:
                type_obj_tab.close()
            if observer.value:
                observer.value=False
            return
        type_obj_tab.close()
        if not observer.value:
            observer.value = True
        return

    def change_view():
        select_obj()
    axipy.selection_manager.changed.connect(select_obj)
    axipy.view_manager.active_changed.connect(change_view)
    #editable_layer_changed
    select_obj()

    return observer
