import axipy
from axipy import AxiomaInitLogLevel, init_axioma, Feature

from ru_axioma_gis_add_geo_tools.tools.line_pairing.tools.pairing_line import LinePairing

app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_tab=r"E:\Support\AxiomaTesting\Shapely\base_line_2.TAB"
tab=axipy.provider_manager.openfile(path_tab)
fts=list(tab.items())
geo_line_1=fts[0].geometry
geo_line_2=fts[1].geometry
cls_Pair=LinePairing(geo_line_1,geo_line_2)
new_geo_line1,new_geo_line_2,pair_polyline=cls_Pair.build(14)
new_ft=Feature(geometry=pair_polyline,style=fts[0].style)
tab.insert(new_ft)
if new_geo_line1 is not None:
    new_ft = Feature(geometry=new_geo_line1, style=fts[0].style)
    tab.insert(new_ft)
if new_geo_line_2 is not None:
    new_ft = Feature(geometry=new_geo_line_2, style=fts[0].style)
    tab.insert(new_ft)
tab.commit()
app.exit()