import axipy
from axipy import AxiomaInitLogLevel, init_axioma, Feature, Pnt, Line

from ru_axioma_gis_add_geo_tools.tools.line_pairing.tools.pairing_geo_object import SegmentDescription, GeometryPairing, \
    TypeSegment

app=init_axioma(log_level=AxiomaInitLogLevel.disabled,load_python_plugins=False)
path_tab=r"E:\Support\AxiomaTesting\Shapely\base_line_2n.TAB"
path_tab=r"E:\Support\AxiomaTesting\Shapely\base_line_3n.TAB"
tab=axipy.provider_manager.openfile(path_tab)
fts=list(tab.items())
#geo_line_1=fts[0].geometry
p1_1=Pnt(214.105735,232.985476)
p1_2=Pnt(214.105735,	362.121501)
geo_line_1=Line(p1_1,p1_2,cs=tab.coordsystem)
#geo_line_2=fts[1].geometry
p2_1=Pnt(227.115892,311.658849)
p2_2=Pnt(288.953186,	214.422212)
p2_1=Pnt(288.953186,	214.422212)
p2_2=Pnt(306.959071	,186.108688)
#geo_line_2=Line(p2_1,p2_2,cs=tab.coordsystem)
geo_line_2=Line(p2_1,p2_2,cs=tab.coordsystem)
pnt_1_intersect=Pnt(214.105735,	333.151822)
#pnt_1_intersect=Pnt(214.105735,362.121501)
pnt_2_intersect=Pnt(235.373931,298.673418)

seg_prop_1=SegmentDescription(fts[0].id,fts[0].geometry.type,geo_line_1,pnt_1_intersect,TypeSegment.Interior)
seg_prop_2=SegmentDescription(fts[1].id,fts[1].geometry.type,geo_line_2,pnt_2_intersect,TypeSegment.End)
#cls_Pair=LinePairing(geo_line_1,geo_line_2)
cls_Pair=GeometryPairing(seg_prop_1,seg_prop_2)
new_geo_line1,new_geo_line_2,pair_polyline=cls_Pair.build(14)
new_ft=Feature(geometry=pair_polyline,style=fts[0].style)
tab.insert(new_ft)
if new_geo_line1 is not None:
    new_ft = Feature(geometry=new_geo_line1, style=fts[0].style)
    tab.insert(new_ft)
if new_geo_line_2 is not None:
    new_ft = Feature(geometry=new_geo_line_2, style=fts[0].style)
    tab.insert(new_ft)
tab.commit()
app.exit()