import json
import os
from pathlib import Path


class SaveParamsBevel:
    __default_name="pairing_bevel.json"
    def __init__(self,path_folder:Path):
        self.__path=path_folder.joinpath(self.__default_name)
    def save(self,params):
        if self.__path.exists():
            os.remove(str(self.__path))
        with open(str(self.__path), 'w',encoding='utf8') as f:
            json.dump(params, f)
    def load(self):
        if not self.__path.exists():
            return None
        params=None
        with open(str(self.__path), 'r',encoding='utf8') as file:
            params = json.load(file)
        return params
